#ifndef _CLI_FILE_PARAM_H_
#define _CLI_FILE_PARAM_H_

#include <ast/Param.h>
#include <abstraction/Registry.h>

namespace cli {

class FileParam final : public Param {
	std::unique_ptr < cli::Arg > m_arg;

public:
	FileParam ( std::unique_ptr < cli::Arg > arg ) : Param ( true ), m_arg ( std::move ( arg ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		ext::deque < sax::Token > tokens = sax::FromXMLParserHelper::parseInput ( m_arg->eval ( environment ) );
		std::string type = tokens [ 0 ].getData ( );
		return abstraction::Registry::getXmlParserAbstraction ( type, tokens );
	}
};

} /* namespace cli */

#endif /* _CLI_FILE_PARAM_H_ */
