#ifndef _CLI_SINGLE_STATEMENT_H_
#define _CLI_SINGLE_STATEMENT_H_

#include <ast/Statement.h>
#include <abstraction/Registry.h>
#include <exception/CommonException.h>
#include <iostream>

namespace cli {

class SingleStatement final : public Statement {
	std::unique_ptr < cli::Arg > m_name;
	ext::vector < std::unique_ptr < Param > > m_params;
	ext::vector < std::unique_ptr < Option > > m_options;

public:
	SingleStatement ( std::unique_ptr < cli::Arg > name, ext::vector < std::unique_ptr < Param > > params, ext::vector < std::unique_ptr < Option > > options );

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > & prev, Environment & environment ) const override;

	void setHL3 ( ) {
		std::cout << "The cake is a lie, as well as the release date of HL3. GLaDOS told me." << std::endl;
	}
};

} /* namespace cli */

#endif /* _CLI_SINGLE_STATEMENT_H_ */
