#ifndef _CLI_CAST_INTROSPECTION_COMMAND_H_
#define _CLI_CAST_INTROSPECTION_COMMAND_H_

#include <command/Command.h>
#include <environment/Environment.h>

namespace cli {

class CastsIntrospectionCommand : public Command {
	std::unique_ptr < cli::Arg > m_param;
	bool m_from;
	bool m_to;

public:
	CastsIntrospectionCommand (std::unique_ptr < cli::Arg > param, bool from, bool to ) : m_param ( std::move ( param ) ), m_from ( from ), m_to ( to ) {
	}

	virtual Command::Result run ( Environment & environment ) const override {
		std::string param = m_param->eval ( environment );

		if ( m_from )
			abstraction::Registry::listCastsFrom ( param );

		if ( m_to )
			abstraction::Registry::listCastsTo ( param );

		return Command::Result::OK;
	}
};

} /* namespace cli */

#endif /* _CLI_CAST_INTROSPECTION_COMMAND_H_ */
